// Fill out your copyright notice in the Description page of Project Settings.


#include "VisionLink.h"

#include "Camera/CameraComponent.h"
#include "VisionLinkEnemyLOSTest.h"
#include "GameFramework/Character.h"

void AVisionLink::BeginPlay()
{
	Super::BeginPlay();
	SetActorTickEnabled(false);
	CooldownLength = CooldownTime;
	InUseDuration = GadgetMaxUptime;

	if (NumberOfPingPulses <= 0) NumberOfPingPulses = 1;
	TimeInbetweenPingPulses = GadgetMaxUptime / (float)NumberOfPingPulses;
}

void AVisionLink::Activate()
{
	if (GadgetCantBeUsed()) return;

	Super::Activate();

	NumOfPingPulsesLeftInThisCycle = NumberOfPingPulses;
	VisionLinkActivated();
	SendOutPingPulse();
}

void AVisionLink::FinishedUsing()
{
	VisionLinkRecharging();

	Super::FinishedUsing();
}

void AVisionLink::SendOutPingPulse()
{
	NumOfPingPulsesLeftInThisCycle--;
	UpdatePulsesRemaining(NumOfPingPulsesLeftInThisCycle);
	if (NumOfPingPulsesLeftInThisCycle < 0) return;

	FActorSpawnParameters SpawnParams;
	SpawnParams.SpawnCollisionHandlingOverride = ESpawnActorCollisionHandlingMethod::AlwaysSpawn;
	UCameraComponent* PlayerCamComp = Cast<UCameraComponent>(GetWorld()->GetFirstPlayerController()->GetCharacter()->GetComponentByClass(UCameraComponent::StaticClass()));
	//FVector SpawnLoc = PlayerCamComp->GetSocketLocation(NAME_None) + PlayerCamComp->GetForwardVector() * EnemyLOSTestActor->GetDefaultObject()
	
	
	//AActor* LOSTestActor = GetWorld()->SpawnActor<AActor>(EnemyLOSTestActor, SpawnLoc, GetActorRotation(), SpawnParams);
	//TArray<uint32> EmptyIDArray;
	//Cast<AVisionLinkEnemyLOSTest>(LOSTestActor)->TestLOS(EmptyIDArray, this);
	
	UE_LOG(LogTemp, Warning, TEXT("Ping Pulse!"));
	GetWorld()->GetTimerManager().SetTimer(PulseHandle, this, &AVisionLink::SendOutPingPulse, TimeInbetweenPingPulses, false);
	PlayPingPulseAnim(TimeInbetweenPingPulses);
}
